# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import pydantic
import typing
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class SourceArchetype(UncheckedBaseModel):
    archetype_id: str = pydantic.Field()
    """
    The unique identifier for this source archetype
    """

    display_name: str = pydantic.Field()
    """
    The human readable name for this source archetype
    """

    input_schema: typing.Dict[str, typing.Optional[typing.Any]]
    output_schema: typing.Dict[str, typing.Optional[typing.Any]]
    description: typing.Optional[str] = pydantic.Field(default=None)
    """
    A description of this source archetype
    """

    schedulable: typing.Optional[bool] = pydantic.Field(default=None)
    """
    Wether or not this Source can be schedule to run at an interval
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
